<template>
  <section class="grid-template with-borders filters-template">
    <div class="right-border empty-tag" />
    <div class="main-title">
      <h1>{{ glassesTitle }}</h1>
    </div>
    <div class="filters-variants-wrapper">
      <button class="filter-title" @click="changeColorFiltersStatus">COLOUR</button>
      <button class="filter-title" @click="changeShapeFiltersStatus">SHAPE</button>
    </div>
    <ColorsFilters
      :is-filters-opened="isColourFiltersOpened"
      :add-filter="addFilter"
      :is-filter-active="isFilterActive"
    />
    <ShapeFilters
      :is-filters-opened="isShapeFiltersOpened"
      :add-filter="addFilter"
      :is-filter-active="isFilterActive"
    />
    <ActiveFilters
      :is-active-filters-opened="isColourFiltersOpened || isShapeFiltersOpened"
      :active-filters="activeFilters"
      :remove-filter="removeFilter"
      :clear-filters="clearFilters"
      :total-count="totalCount"
    />
  </section>
</template>
<script lang="ts">
import ColorsFilters from './ColorsFilters.vue'
import ShapeFilters from './ShapeFilters.vue'
import ActiveFilters from './ActiveFilters.vue'

import { GLASSES_TYPES, type ActiveFilter } from '@/types/glasses'
export default {
  components: {
    ColorsFilters,
    ShapeFilters,
    ActiveFilters
  },
  props: {
    totalCount: {
      type: Number,
      required: true
    },
    fetchGlasses: {
      type: Function,
      required: true
    },
    isLoading: {
      type: Boolean,
      required: true
    },
    activeFilters: {
      type: Array as () => ActiveFilter[],
      required: true
    },
    addFilter: {
      type: Function,
      required: true
    },
    removeFilter: {
      type: Function,
      required: true
    },
    clearFilters: {
      type: Function,
      required: true
    },
    glassesType: {
      type: String as () => GLASSES_TYPES,
      required: true
    }
  },
  data() {
    return {
      isColourFiltersOpened: false,
      isShapeFiltersOpened: false
    }
  },
  methods: {
    changeColorFiltersStatus() {
      this.isColourFiltersOpened = !this.isColourFiltersOpened
    },
    changeShapeFiltersStatus() {
      this.isShapeFiltersOpened = !this.isShapeFiltersOpened
    },

    isFilterActive(filter: ActiveFilter) {
      return Boolean(this.activeFilters.find((element) => element.name === filter.name))
    }
  },
  computed: {
    glassesTitle(): string {
      return this.glassesType.replace(/-/g, ' ')
    }
  }
}
</script>
